#!/usr/bin/env python

from parallel import start, Exchange
from Dict import Indexer, Searcher, update

def apply_indexer(channel, filename):
    print "Indexing", filename
    indexer = Indexer(filename)
    channel.send(indexer.get_index())

def get_searcher(filenames, window_size):
    master_index = {}

    # Start indexing.

    for i in range(0, len(filenames), window_size):
        channels = []
        for filename in filenames[i:i + window_size]:
            channels.append(start(apply_indexer, filename))

        # Start listening for responses.

        exchange = Exchange(channels)
        while exchange.active():
            print "Waiting for %d channels..." % exchange.active()
            for channel in exchange.ready():
                index = channel.receive()
                update(master_index, index)
                exchange.remove(channel)
                channel.close()

    # Provide a search interface.

    return Searcher(master_index)

if __name__ == "__main__":
    import sys, os
    window_size, directory = int(sys.argv[1]), sys.argv[2]
    filenames = [os.path.join(directory, filename) for filename in os.listdir(directory)]

    searcher = get_searcher(filenames, window_size)
    while 1:
        print "Pattern:",
        pattern = raw_input()
        print searcher.find(pattern)

# vim: tabstop=4 expandtab shiftwidth=4
